require 'net/ssh'

module Asteroid
  class Instance

    def ssh_exec(command)
      ssh.exec!(command) do |channel, stream, data|
        if stream == :stdout
          puts data
        else
          puts data
        end
      end
    end

    def ssh
      if @ssh && (@ssh.transport.port.to_s != self["ssh.port"] || (@ssh.transport.options[:user] != self["login.username"]))
        @ssh = nil
      end

      @ssh ||= Net::SSH.start(
        ip_address, 
        self["login.username"], 
        port: self["ssh.port"].to_i,
        :keys => [server.ssh_key.private.filename]
      )
    end
    
  end  
end