# :name=>"web-1c5c2972",
# :image_id=>3101918,
# :size_id=>66,
# :region_id=>4,
# :backups_active=>false,
# :ip_address=>"107.170.109.79",
# :private_ip_address=>"10.128.197.52",
# :locked=>false,
# :status=>"active",
# :created_at=>"2014-04-12T20:44:53Z"}

module Asteroid
  module Provider
    class VirtualBox

      def initialize(options = {})
      end

      def self.type
        :virtual_box
      end

      def instances
        instances = `VBoxManage list vms`.split /\n/
        instances.map do |line|
          matches = line.match /\"(\S+)\" {(\S+)}/
          name, uuid = matches[0], matches[1]
          ip_address = `VBoxManage guestproperty get "#{uuid}" "/VirtualBox/GuestInfo/Net/0/V4/IP" | awk '{ print $2 }'`
          {
            id: uuid,
            name: name,
            ip_address: ip_address,
            provider: self
          }
        end
      end
      
      def destroy_instance(instance)
      end

    end
  end
end